//+------------------------------------------------------------------+
//|                                               Advanced forecater |
//|                                                                  |
///+-----------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 2

extern int FastEma    = 13;
extern int SlowEma    = 34;
extern int SignalSMA  = 8;

double temp1[];
double temp2[];
double sum[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0,sum);
   SetIndexBuffer(1,temp1);
   SetIndexBuffer(2,temp2);
   IndicatorShortName("Advanced_forecater");
   return (0);
}

int start() 
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int i,limit = MathMin(Bars-countedBars,Bars-1);
            double Multiply_Factor_1 = 2.0 / (FastEma + 1.0);
            double Multiply_Factor_2 = 2.0 / (SlowEma + 1.0);
            double Multiply_Factor_3 = Multiply_Factor_1 - Multiply_Factor_2;
                  if (MathAbs(Multiply_Factor_3) == 0.0) return(0);

   //
   //
   //
   //
   //
 
   for(i=limit; i>=0; i--) temp1[i] = iMA(NULL,0,FastEma,0,MODE_EMA, PRICE_CLOSE,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) temp2[i] = iMAOnArray(temp1,0,SignalSMA,0,MODE_SMA,i);
   for(i=limit; i>=0; i--)
      sum[i] = (Multiply_Factor_1 * iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)+                  iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) - 
                                    iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)-Multiply_Factor_2*iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) + temp2[i]) / Multiply_Factor_3;
   return (0);
}